package org.jvnet.hifaces.components.templatedpanel.impl;

import java.io.BufferedInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.net.URL;

import org.w3c.dom.Element;
import org.xml.sax.SAXException;

public class URLTemplateResource implements TemplateResource {

	private final URL url;

	public URLTemplateResource(final URL url) {
		this.url = url;
	}

	public String getKey() {
		return url.toString();
	}

	public Element getAsDomElement() throws IOException, SAXException {

		InputStream is = null;
		try {
			is = new BufferedInputStream(url.openStream(), 1024);
			return ParseUtilities.parse(is);
		} finally {
			if (is != null) {
				try {
					is.close();
				} catch (IOException ex) {
					// Ignore the exception;
				}
			}
		}
	}

	public long getLastModified() throws IOException {
		return url.openConnection().getLastModified();
	}

}
