package org.jvnet.hifaces.convert;

import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.convert.Converter;
import javax.faces.convert.ConverterException;

public class BooleanConverter implements Converter {

	private static final String CONVERSION_MESSAGE_ID = "org.jvnet.hifaces.convert.BooleanConverter.CONVERSION";

	public static final String CONVERTER_ID = "org.jvnet.hifaces.Boolean";

	public BooleanConverter() {
	}

	public Object getAsObject(FacesContext facesContext,
			UIComponent uiComponent, String value) {
		if (facesContext == null)
			throw new NullPointerException("facesContext");
		if (uiComponent == null)
			throw new NullPointerException("uiComponent");
		if (value == null) {
			return null;
		} else {
			value = value.trim();
			if ("".equals(value) || "#".equals(value)) {
				return null;
			} else {
				if ("true".equals(value)) {
					return Boolean.TRUE;
				} else if ("false".equals(value)) {
					return Boolean.FALSE;
				} else {
					throw new ConverterException(MessageUtils.getErrorMessage(
							facesContext, CONVERSION_MESSAGE_ID, new Object[] {
									value, uiComponent.getId() }));
				}
			}
		}
	}

	public String getAsString(FacesContext facesContext,
			UIComponent uiComponent, Object value) {
		if (facesContext == null)
			throw new NullPointerException("facesContext");
		if (uiComponent == null)
			throw new NullPointerException("uiComponent");

		if (value == null) {
			return "#";
		}
		if (value instanceof String) {
			return (String) value;
		}
		try {
			return ((Boolean) value).toString();
		} catch (Exception e) {
			throw new ConverterException(e);
		}
	}
}
