package org.jvnet.hifaces.text;

import java.util.Calendar;

import javax.faces.context.FacesContext;
import javax.faces.el.ValueBinding;

public class CalendarText extends Text {

	private static final long serialVersionUID = 1L;

	public static final String DATE_FORMAT_MESSAGE_ID = "_dateFormat";

	public static final String DATETIME_FORMAT_MESSAGE_ID = "_dateTimeFormat";

	public static final String TIME_FORMAT_MESSAGE_ID = "_timeFormat";

	private final ValueBinding valueBinding;

	public CalendarText(String messageId, ValueBinding valueBinding) {
		super(messageId);
		this.valueBinding = valueBinding;
	}

	@Override
	protected Object[] getArguments(FacesContext facesContext) {
		final Calendar calendar = (Calendar) valueBinding
				.getValue(facesContext);
		return new Object[] { calendar.getTime() };
	}

	public static ValueBinding date(ValueBinding valueBinding) {
		return new CalendarText(DATE_FORMAT_MESSAGE_ID, valueBinding);
	}

	public static ValueBinding dateTime(ValueBinding valueBinding) {
		return new CalendarText(DATETIME_FORMAT_MESSAGE_ID, valueBinding);
	}

	public static ValueBinding time(ValueBinding valueBinding) {
		return new CalendarText(TIME_FORMAT_MESSAGE_ID, valueBinding);
	}
}
