package org.jvnet.hifaces.util;

import java.util.Collection;

import javax.faces.component.UIComponent;
import javax.faces.el.ValueBinding;

import org.apache.commons.lang.Validate;

public class ComponentUtils {

	private ComponentUtils() {
	}

	public static <T extends UIComponent> T renderedOn(T component,
			ValueBinding rendered) {
		Validate.notNull(component, "Command must not be null.");
		Validate.notNull(rendered, "Rendered value binding must not be null.");
		component.setValueBinding("rendered", rendered);
		return component;
	}

	public static <T extends UIComponent> T addChildren(T parent,
			UIComponent... children) {
		if (parent != null) {
			if (children != null) {
				for (final UIComponent child : children) {
					if (child != null) {
						parent.getChildren().add(child);
					}
				}
			}
		}
		return parent;
	}

	public static <T extends UIComponent> T addChildren(T parent,
			Collection<UIComponent> children) {
		if (parent != null) {
			if (children != null) {
				for (final UIComponent child : children) {
					if (child != null) {
						parent.getChildren().add(child);
					}
				}
			}
		}
		return parent;
	}

}
